-- Client-side script

local currentVisionMode = 0 -- 0 = normal, 1 = NVG, 2 = Thermal

-- Function to play visor toggle animation (synchronized)
local function PlayVisorAnimation()
    local ped = PlayerPedId()
    local animDict = "mp_masks@standard_car@ds@"
    local animName = "put_on_mask"
    
    RequestAnimDict(animDict)
    while not HasAnimDictLoaded(animDict) do
        Citizen.Wait(10)
    end
    
    -- Use synchronized animation
    TriggerServerEvent("syncVisorAnimation")
end

-- Event handler for synchronized animation
RegisterNetEvent("playVisorAnimationForAll")
AddEventHandler("playVisorAnimationForAll", function(playerId)
    local playerPed = GetPlayerPed(GetPlayerFromServerId(playerId))
    if DoesEntityExist(playerPed) and not IsEntityDead(playerPed) then
        local animDict = "mp_masks@standard_car@ds@"
        local animName = "put_on_mask"
        
        RequestAnimDict(animDict)
        while not HasAnimDictLoaded(animDict) do
            Citizen.Wait(10)
        end
        
        TaskPlayAnim(playerPed, animDict, animName, 8.0, -8.0, 800, 49, 0, false, false, false)
    end
end)

-- Function to set vision mode
local function SetVisionMode(mode)
    PlayVisorAnimation()
    
    Citizen.Wait(300) -- Wait for the animation to progress before applying the effect
    
    if mode == 0 then -- Normal vision
        SetNightvision(false)
        SetSeethrough(false)
        PlaySoundFrontend(-1, "NightVisionOff", "CAMERA_GALLERY_SOUNDS", 1)
    elseif mode == 1 then -- Night vision
        SetNightvision(true)
        SetSeethrough(false)
        SetNightvisionEffectStrength(1.0)
        PlaySoundFrontend(-1, "NightVision", "CAMERA_GALLERY_SOUNDS", 1)
    elseif mode == 2 then -- Thermal vision
        SetNightvision(false)
        SetSeethrough(true)
        PlaySoundFrontend(-1, "NightVision", "CAMERA_GALLERY_SOUNDS", 1)
    end
    
    currentVisionMode = mode
end

-- Event handler for toggling vision mode
RegisterNetEvent("toggleVisionMode")
AddEventHandler("toggleVisionMode", function(mode)
    SetVisionMode(mode)
end)

-- Main loop to ensure vision mode stays active
Citizen.CreateThread(function()
    while true do
        Citizen.Wait(0)
        if currentVisionMode == 1 then
            SetNightvision(true)
        elseif currentVisionMode == 2 then
            SetSeethrough(true)
        end
    end
end)