-- Server-side script
local function printInfo()
    local version = GetResourceMetadata(GetCurrentResourceName(), 'version')

    local message = string.format([[^3
╔════════════════════════════════════════════════════════════════╗
║                                                                ║
║   ^4███╗   ██╗██╗   ██╗ ██████╗                                  ^3║
║   ^4████╗  ██║██║   ██║██╔════╝                                  ^3║
║   ^4██╔██╗ ██║██║   ██║██║  ███╗                                 ^3║
║   ^4██║╚██╗██║╚██╗ ██╔╝██║   ██║                                 ^3║
║   ^4██║ ╚████║ ╚████╔╝ ╚██████╔╝                                 ^3║
║   ^4╚═╝  ╚═══╝  ╚═══╝   ╚═════╝                                  ^3║
║                                                                ║
║   ^2████████╗██╗  ██╗███████╗██████╗ ███╗   ███╗ █████╗ ██╗      ^3║
║   ^2╚══██╔══╝██║  ██║██╔════╝██╔══██╗████╗ ████║██╔══██╗██║      ^3║
║   ^2   ██║   ███████║█████╗  ██████╔╝██╔████╔██║███████║██║      ^3║
║   ^2   ██║   ██╔══██║██╔══╝  ██╔══██╗██║╚██╔╝██║██╔══██║██║      ^3║
║   ^2   ██║   ██║  ██║███████╗██║  ██║██║ ╚═╝ ██║██║  ██║███████╗ ^3║
║   ^2   ╚═╝   ╚═╝  ╚═╝╚══════╝╚═╝  ╚═╝╚═╝     ╚═╝╚═╝  ╚═╝╚══════╝ ^3║
║                                                                ║
║   ^5███████╗ ██████╗██████╗ ██╗██████╗ ████████╗                 ^3║
║   ^5██╔════╝██╔════╝██╔══██╗██║██╔══██╗╚══██╔══╝                 ^3║
║   ^5███████╗██║     ██████╔╝██║██████╔╝   ██║                    ^3║
║   ^5╚════██║██║     ██╔══██╗██║██╔═══╝    ██║                    ^3║
║   ^5███████║╚██████╗██║  ██║██║██║        ██║                    ^3║
║   ^5╚══════╝ ╚═════╝╚═╝  ╚═╝╚═╝╚═╝        ╚═╝                    ^3║
║                                                                ║
║                     ^1NVG THERMAL SCRIPT^3                         ║
║                                                                ║
║   ^6Author: xEUNOIAx     Version: %s                          ^3║
║   ^6Discord: https://discord.gg/QZEcrMM9V5                       ^3║
║                                                                ║
╚════════════════════════════════════════════════════════════════╝^7
]], version)

    print(message)
end

-- Print info when the resource starts
AddEventHandler('onResourceStart', function(resourceName)
    if (GetCurrentResourceName() ~= resourceName) then
      return
    end
    printInfo()
end)

-- Table to keep track of players' vision modes (0 = normal, 1 = NVG, 2 = Thermal)
local playerVisionModes = {}

-- Register command to cycle vision modes
RegisterCommand("visor", function(source, args, rawCommand)
    local playerId = source
    
    local currentMode = playerVisionModes[playerId] or 0
    local newMode = (currentMode + 1) % 3
    
    playerVisionModes[playerId] = newMode
    
    local modeNames = {"Normal", "Night Vision", "Thermal Vision"}
    TriggerClientEvent("toggleVisionMode", playerId, newMode)
    TriggerClientEvent("chatMessage", playerId, "^2[MTRP VISOR]", {255, 255, 255}, modeNames[newMode + 1] .. " mode activated.")
end, false)

-- Remove player from the table when they disconnect
AddEventHandler("playerDropped", function()
    local playerId = source
    playerVisionModes[playerId] = nil
end)

-- Event handler for synchronized animation
RegisterServerEvent("syncVisorAnimation")
AddEventHandler("syncVisorAnimation", function()
    local playerId = source
    TriggerClientEvent("playVisorAnimationForAll", -1, playerId)
end)